USACO2014Open Silver Odometer

Task:
Farmer John’s cows are on a road trip! The odometer on their car
displays an integer mileage value, starting at X (100 <= X <= 10^18)
miles at the beginning of their trip and ending at Y (X <= Y <= 10^18)
miles at the end of their trip. Whenever the odometer displays an
‘interesting’ number (including at the start and end of the trip) the
cows will moo. A number is ‘interesting’ if when you look at all its
digits except for leading zeros, at least half of these should be the
same. For example, the numbers 3223 and 110 are interesting, while
the numbers 97791 and 123 are not.
Help FJ count how many times the cows will moo during the trip.

SAMPLE INPUT
110 133

SAMPLE OUTPUT
14

Solution:
一道简单的数位dp题,我们可以将算[X,Y]内的有趣数转化为算[1,X),[1,Y]内的有趣数,然后通过减法算出[X,Y]内的有趣数.

好,我们定义dp[i][j][k][l],i为已经dp到第几位(从高到低),j为现在的数是否已经小于所要求的数(如果小于就能随便取了),k为现在你需要的数所占的比例(取了几次,取一次-1,取别的+1),l为现在是否还是前导零(如果有就能随便放0).

这样,我们每次枚举占一半数量的数是哪一个,就可以用数位dp来算出这些的个数了.

然而,我们将形如1122,3344等数计算了两遍(1算了1122后,2又算了1122),把他们减掉就好了.

#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<string>
#define M 55
#define LL long long
using namespace std;
LL dp[M][2][M][2];
string X,Y;
LL DP(string res,int len,int de1,int de2){
    LL ret=0;
    memset(dp,0,sizeof(dp));
    dp[0][0][25][1]=1;
    for(int i=0;i<len;i++)
        for(int j=0;j<2;j++)
            for(int k=0;k<M;k++)
                for(int l=0;l<2;l++){
                    LL now=dp[i][j][k][l];
                    for(int nx=0;nx<=9;nx++){
                        if(de2!=-1&&(nx!=0||l==0)&&nx!=de2&&nx!=de1)continue;
                        if(j==0&&nx>res[i]-'0')continue;
                        int nj=j|(nx<res[i]-'0'),nk=k,nl=l;
                        nl&=(nx==0);
                        if(nl==0){
                            if(de2==-1){
                                if(de1==nx)nk--;
                                else nk++;
                            }else if(de2!=-1){
                                if(de1==nx)nk--;
                                else if(de2==nx)nk++;
                            }
                        }
                        dp[i+1][nj][nk][nl]+=now;
                    }
                }
    if(de2==-1){
        for(int i=0;i<2;i++)
            for(int j=0;j<=25;j++)
                ret+=dp[len][i][j][0];
    }else {
        for(int i=0;i<2;i++)
            ret+=dp[len][i][25][0];
    }
    return ret;
}
LL solve(string res){
    LL ret=0;
    int len=res.length();
    for(int i=0;i<=9;i++)ret+=DP(res,len,i,-1);
    for(int i=0;i<=9;i++)
        for(int j=i+1;j<=9;j++)
            ret-=DP(res,len,i,j);
    return ret;
}
int main(){
    cin>>X>>Y;
    for(int i=X.length()-1;i>=0;i--)
        if(X[i]=='0')X[i]='9';
        else {
            X[i]--;
            break;
        }
    cout<<solve(Y)-solve(X)<<endl;
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
Bill and Ted are taking a road trip. But the odometer in their car is broken, so they don't know how many miles they have driven. Fortunately, Bill has a working stopwatch, so they can record their speed and the total time they have driven. Unfortunately, their record keeping strategy is a little odd, so they need help computing the total distance driven. You are to write a program to do this computation. For example, if their log shows Speed in miles perhour Total elapsed time in hours 20 2 30 6 10 7 this means they drove 2 hours at 20 miles per hour, then 6-2=4 hours at 30 miles per hour, then 7-6=1 hour at 10 miles per hour. The distance driven is then (2)(20) + (4)(30) + (1)(10) = 40 + 120 + 10 = 170 miles. Note that the total elapsed time is always since the beginning of the trip, not since the previous entry in their log. Input The input consists of one or more data sets. Each set starts with a line containing an integer n, 1 <= n <= 10, followed by n pairs of values, one pair per line. The first value in a pair, s, is the speed in miles per hour and the second value, t, is the total elapsed time. Both s and t are integers, 1 <= s <= 90 and 1 <= t <= 12. The values for t are always in strictly increasing order. A value of -1 for n signals the end of the input. Output For each input set, print the distance driven, followed by a space, followed by the word "miles" Sample Input 3 20 2 30 6 10 7 2 60 1 30 5 4 15 1 25 2 30 3 10 5 -1 Sample Output 170 miles 180 miles 90 miles

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值